Package: SubcellularSpatialData
Title: Annotated spatial transcriptomics datasets from 10x Xenium,
        NanoString CosMx and BGI STOmics.
Version: 1.9.0
Authors@R: c(
            person(given = "Dharmesh D.",
                   family = "Bhuva",
                   role = c("aut", "cre"),
                   email = "dharmesh.bhuva@adelaide.edu.au",
                   comment = c(ORCID = "0000-0002-6398-9157"))
            )
Description: This is a data package that hosts annotated sub-cellular localised datasets from the STOmics, Xenium and CosMx platforms. Specifically, it hosts datasets analysed in the publication Bhuva et. al, 2024 titled "Library size confounds biology in spatial transcriptomics data". Raw transcript detections are hosted and functions to convert them to SpatialExperiment objects have been implemented.
biocViews: ExperimentHub, SpatialData, Homo_sapiens_Data,
        Mus_musculus_Data, LungCancerData
License: GPL (>= 3)
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
URL: https://davislaboratory.github.io/SubcellularSpatialData
BugReports: https://github.com/DavisLaboratory/SubcellularSpatialData/issues
Imports: dplyr, hexbin, Matrix, SpatialExperiment, stats
NeedsCompilation: no
VignetteBuilder: knitr
Suggests: BiocStyle, ExperimentHub, ggplot2, knitr, prettydoc,
        rmarkdown, testthat (>= 3.0.0)
Depends: R (>= 4.4)
LazyData: false
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/SubcellularSpatialData
git_branch: devel
git_last_commit: 7a2f671
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-30
Packaged: 2026-04-30 16:02:02 UTC; biocbuild
Author: Dharmesh D. Bhuva [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-6398-9157>)
Maintainer: Dharmesh D. Bhuva <dharmesh.bhuva@adelaide.edu.au>

# SubcellularSpatialData

<!-- badges: start -->
<!-- badges: end -->

The data in this package is published in the publication Bhuva et al., _Genome Biology_, 2024. Annotations for each dataset are obtained independently of the molecular measurements. The lowest level of measurement is annotated for each dataset. For BGI STOmics, this is each DNA nanoball, and for 10x Xenium and NanoString CosMx, these are the individual transcript detections. The package provides functions to convert these unit measurements into higher level summaries such as cells, regions, square bins, or hex bins for analysis purposes. These summaries are stored in SpatialExperiment objects.

## Installation

The release version can be downloaded as follows:

``` r
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("SubcellularSpatialData")
```

You can install the development version of SubcellularSpatialData from [GitHub](https://github.com/) with:

``` r
# install.packages("devtools")
devtools::install_github("DavisLaboratory/SubcellularSpatialData")
```

## Example

This is a basic example which shows you how to solve a common problem:

``` r
library(SubcellularSpatialData)
## basic example code
```

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  warning = FALSE,
  message = FALSE,
  comment = "#>"
)

## ----eval=FALSE---------------------------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("SubcellularSpatialData")

## ----load-packages, message=FALSE---------------------------------------------
library(SubcellularSpatialData)
library(ExperimentHub)

## ----get-SubcellularSpatialData-----------------------------------------------
eh = ExperimentHub()
query(eh, "SubcellularSpatialData")

## ----download-SubcellularSpatialData, eval=FALSE------------------------------
# eh[["EH8230"]]

## -----------------------------------------------------------------------------
# load internal sample data
data(tx_small)
# view data
head(tx_small)

## -----------------------------------------------------------------------------
library(ggplot2)
tx_small |>
  ggplot(aes(x, y, colour = region)) +
  geom_point(pch = ".") +
  scale_colour_brewer(palette = "Set2", guide = guide_legend(override.aes = list(shape = 15, size = 5))) +
  facet_wrap(~sample_id, ncol = 2, scales = "free") +
  theme_minimal() +
  theme(legend.position = "bottom")

## -----------------------------------------------------------------------------
library(SpatialExperiment)

# summarising counts per cell
tx2spe(tx_small, bin = "cell")

# summarising counts per square bin
tx2spe(tx_small, bin = "square", nbins = 30)

# summarising counts per hex bin
tx2spe(tx_small, bin = "hex", nbins = 30)

# summarising counts per region
tx2spe(tx_small, bin = "region")

## -----------------------------------------------------------------------------
sessionInfo()

#' @details
#' The data in this package is published in the publication Bhuva et al., _Genome Biology_, 2024. Annotations for each dataset are obtained independently of the molecular measurements. The lowest level of measurement is annotated for each dataset. For BGI STOmics, this is each DNA nanoball, and for 10x Xenium and NanoString CosMx, these are the individual transcript detections.
#' 
#' The package provides the \code{\link{tx2spe}} function to convert these unit measurements into higher level summaries such as cells, regions, square bins, or hex bins for analysis purposes. These summaries are stored in SpatialExperiment objects.
#' 
#' @keywords internal
"_PACKAGE"

#' Sample annotated sub-cellular localised spatial 'omics dataset
#'
#' This object stores a sample transcript table to demonstrate the format of data stored within this package. The sample dataset contains 100,000 transcript detections from 2 breast cancer samples profiled using the 10x Xenium platform.
#'
#' @format A data.frame where each row represents a transcript detection. The full description of these transcript tables is available in the vignettes or in the documentation for the `tx2spe()` function.
#' @docType data
#'
"tx_small"

library(SpatialExperiment)
library(dplyr)

#download data from websites and load as table
#  - added annotation column where each detection is mapped onto annotations
#  - annotations are stored in geojson files (see paper for description on how they
#    were obtained Bhuva et al. 2023)

#xenium - brain
df = readRDS('data-local/Xenium_Mar23.rds') |> 
  dplyr::rename(cell = cell_id, gene = feature_name, x = x_location, y = y_location) |> 
  mutate(
    genetype = case_when(
      grepl('BLANK', gene) ~ 'NegBlank',
      grepl('NegControlProbe', gene) ~ 'NegPrb',
      grepl('NegControlCodeword', gene) ~ 'NegCW',
      TRUE ~ 'Gene'
    ),
    cell = ifelse(cell == -1, NA_integer_, cell),
    counts = 1,
    technology = 'Xenium'
  ) |> 
  dplyr::rename(region = RegionID, level = Level) |> 
  dplyr::rename(sample = 'sample_id') |> 
  relocate(sample_id, cell, gene, genetype, x, y, counts, region, technology, level, Level0:Level11)
saveRDS(df, 'data-local/xenium_mm_brain.rds')

#xenium - breast
df = readRDS('data-local/Xenium_breast_addon_tx_annotated.rds') |> 
  dplyr::rename(cell = cell_id, gene = feature_name, x = x_location, y = y_location) |> 
  mutate(
    genetype = case_when(
      grepl('BLANK', gene) ~ 'NegBlank',
      grepl('NegControlProbe', gene) ~ 'NegPrb',
      grepl('NegControlCodeword', gene) ~ 'NegCW',
      TRUE ~ 'Gene'
    ),
    cell = ifelse(cell == -1, NA_integer_, cell),
    counts = 1,
    technology = 'Xenium'
  ) |> 
  dplyr::rename(region = RegionID) |> 
  dplyr::rename(sample_id = 'sample') |> 
  relocate(sample_id, cell, gene, genetype, x, y, counts, region, technology)
saveRDS(df, 'data-local/xenium_hs_breast_addon.rds')

#stomics
df = readRDS('data-local/STOmics_Brain.rds') |> 
  select(!UMICount) |> 
  dplyr::rename(gene = geneID, cell = label, counts = MIDCounts) |> 
  mutate(technology = 'STOmics', genetype = 'Gene') |> 
  dplyr::rename(region = RegionID, level = Level) |> 
  dplyr::rename(sample = 'sample_id') |> 
  relocate(sample_id, cell, gene, genetype, x, y, counts, region, technology, level, Level0:Level11)
saveRDS(df, 'data-local/stomics_mm_brain.rds')

#cosmx
df = readRDS('data-local/CosMx_NSCLC_tx_annotated.rds') |> 
  select(!c(sample, x, y)) |> 
  dplyr::rename(
    sample = TMA,
    x = x_global_px,
    y = y_global_px,
    gene = target,
    cell = cell_ID
  ) |>
  dplyr::mutate(cell = ifelse(cell == 0, NA, cell), cell = paste(fov, cell, sep = '_')) |>
  dplyr::select(sample, x, y, gene, cell, fov, Level1, Level2, RegionID) |>
  mutate(
    technology = 'CosMx',
    genetype = ifelse(grepl('NegPrb', gene), 'NegPrb', 'Gene'),
    cell = ifelse(grepl('NA$', cell), NA_character_, cell),
    counts = 1
  ) |> 
  mutate(RegionID = case_when(
    RegionID %in% c('Tumour area with stroma', 'Epithelium - panCK+', 'Tumour area') ~ 'Tumour',
    RegionID %in% c('Abnormal but not tumour') ~ 'Abnormal epithelium',
    RegionID %in% 'Fibrotic area' ~ 'Fibrotic',
    RegionID %in% 'Necrotic area' ~ 'Necrotic',
    RegionID %in% 'Abnormal area' ~ 'Abnormal',
    TRUE ~ RegionID
  )) |> 
  dplyr::rename(region = RegionID) |> 
  dplyr::rename(sample = 'sample_id') |> 
  relocate(sample_id, cell, gene, genetype, x, y, counts, region, technology, Level1:Level2)
saveRDS(df, 'data-local/cosmx_hs_nsclc.rds')

##build record
meta = rbind(
  c(
    Title = 'xenium_mm_brain',
    Description = '10x Xenium dataset of 3 serial sections of fresh frozen mouse brain. Raw transcript level data is provided with region annotations for each detection obtained using image registration of the DAPI image to the Allen Brain Atlas. The Aligning Big Brain Atlases (ABBA) plugin in ImageJ was used for image registration.',
    BiocVersion = 3.18,
    Genome = NA,
    SourceType = 'CSV',
    SourceUrl = 'https://www.10xgenomics.com/resources/datasets/fresh-frozen-mouse-brain-replicates-1-standard',
    SourceVersion = '2023-03-09',
    Species = 'Mus musculus',
    TaxonomyId = '10090',
    Coordinate_1_based = TRUE,
    DataProvider = '10x',
    Maintainer = 'Dharmesh D. Bhuva <dharmesh.bhuva@adelaide.edu.au>',
    RDataClass = 'data.frame',
    DispatchClass = 'Rds',
    Location_Prefix = 'https://zenodo.org',
    RDataPath = 'record/7959787/files/xenium_mm_brain.rds'
  ),
  c(
    Title = 'stomics_mm_brain',
    Description = 'BGI STOmics dataset of the mouse brain. Raw DNA nanoball spot level data is provided with region annotations for each spot obtained using image registration of the DAPI image to the Allen Brain Atlas. The Aligning Big Brain Atlases (ABBA) plugin in ImageJ was used for image registration.',
    BiocVersion = 3.18,
    Genome = NA,
    SourceType = 'TSV',
    SourceUrl = 'https://ftp.cngb.org/pub/SciRAID/stomics/STDS0000058/Bin1_matrix/Mouse_brain_Adult_GEM_bin1.tsv.gz',
    SourceVersion = '2023-03-09',
    Species = 'Mus musculus',
    TaxonomyId = '10090',
    Coordinate_1_based = TRUE,
    DataProvider = 'BGI',
    Maintainer = 'Dharmesh D. Bhuva <dharmesh.bhuva@adelaide.edu.au>',
    RDataClass = 'data.frame',
    DispatchClass = 'Rds',
    Location_Prefix = 'https://zenodo.org',
    RDataPath = 'record/7959787/files/stomics_mm_brain.rds'
  ),
  c(
    Title = 'cosmx_hs_nsclc',
    Description = 'NanoString CosMx dataset of FFPE tissues from 5 non-small cell lung cancer (NSCLC) patients. Lung 5 has 2 serial sections while Lung 9 has 2 non-serial (different location of the tumour) sections from the same patient. Raw transcript level data is provided with region annotations for each detection obtained using expert annotation from a biologist.',
    BiocVersion = 3.18,
    Genome = NA,
    SourceType = 'CSV',
    SourceUrl = 'https://nanostring.com/products/cosmx-spatial-molecular-imager/nsclc-ffpe-dataset',
    SourceVersion = '2023-03-09',
    Species = 'Homo sapiens',
    TaxonomyId = '9606',
    Coordinate_1_based = TRUE,
    DataProvider = 'NanoString',
    Maintainer = 'Dharmesh D. Bhuva <dharmesh.bhuva@adelaide.edu.au>',
    RDataClass = 'data.frame',
    DispatchClass = 'Rds',
    Location_Prefix = 'https://zenodo.org',
    RDataPath = 'record/7959787/files/cosmx_hs_nsclc.rds'
  ),
  c(
    Title = 'xenium_hs_breast_addon',
    Description = '10x Xenium dataset of an intraductal carcinoma (IDC) and intralobular carcinoma (ILC) breast cancers. Raw transcript level data is provided with region annotations for each detection obtained using by annotating the accompanying histology image (H&E).',
    BiocVersion = 3.19,
    Genome = NA,
    SourceType = 'CSV',
    SourceUrl = 'https://www.10xgenomics.com/datasets/ffpe-human-breast-with-custom-add-on-panel-1-standard',
    SourceVersion = '2024-01-31',
    Species = 'Homo sapiens',
    TaxonomyId = '9606',
    Coordinate_1_based = TRUE,
    DataProvider = '10x',
    Maintainer = 'Dharmesh D. Bhuva <dharmesh.bhuva@adelaide.edu.au>',
    RDataClass = 'data.frame',
    DispatchClass = 'Rds',
    Location_Prefix = 'https://zenodo.org',
    RDataPath = "record/10516814/files/xenium_hs_breast_addon.rds"
  )
)

#write and test metadata file
write.csv(meta, file = 'inst/extdata/metadata.csv', row.names = FALSE)
ExperimentHubData::makeExperimentHubMetadata('../SubcellularSpatialData')

#' Compute cell/bin-level summaries and save to a SpatialExperiment object
#'
#' This function summarises transcript detection (or DNA nanoball spot counts) into cells or hexbins and returns a SpatialExperiment object. Annotations of cells or hexbins are summarised such that the most frequent annotation is used.
#'
#' @param x a data.frame containing a sub-cellular localised dataset from the SubcellularSpatialData package.
#' @param bin a character, stating whether transcripts should be binned into cells or hexbins. The default is 'cell', however, it is advisable to use 'hexbin' when cell identification is not accurate (e.g., when cell boundaries are inferred only from nuclei and not directly measured using cytoplasmic/cell membrane stains).
#' @param nbins a numeric, stating the number of bins to create in the x and y axes
#' 
#' @details
#' 
#' ## Data description
#' This function works on all data associated with this package. For new datasets, the transcript table MUST have the following columns:
#' \itemize{
#'  \item{sample_id} {Unique identifier for the sample the transcript belongs to.}
#'  \item{cell} {Unique identifier for the cell the transcript belongs to (NA if it is not allocated to any cell).}
#'  \item{gene} {Gene name or identity of the transcript.}
#'  \item{genetype} {Type of target (e.g., gene or control probe). True genes should be annotated as "Gene". Other target types can be named as desired.}
#'  \item{x} {x-coordinate of the transcript.}
#'  \item{y} {y-coordinate of the transcript.}
#'  \item{counts} {Number of transcripts detected at this location (always 1 for NanoString CosMx and 10x Xenium as each row is an individual detection).}
#'  \item{technology} {Name of the platform the data was sequenced on. "STOmics" is treated differently as the number of spots as well as the number of nuclei/cells are counted. No specific format required for other technologies.} 
#' }
#' 
#' The "region" column is optional and only required if binning by regions. If present, it must be a character or factor. For datasets within this package, this column stored the independently annotated histological region.
#' 
#' ## Summarisation
#' When transcript counts are aggregated (using any approach), aggregation of numeric columns is performed using the `mean(..., na.rm = TRUE)` function and aggregation of character/factor columns is performed such that the most frequent class becomes the representative class. As such, for a hex bin, the highest frequency region for the transcripts allocated to the bin becomes the bin's region annotation. New coordinates for cells, bins, or regions are computed using the mean function as well, therefore represent the center of mass for the object. For hex and square bins, the average coordinate is computed by default, however, x and y indices for the bin are stored in the colData under the *bin_x* and *bin_y* columns. 
#' 
#' When aggregation is perfomed using bins or regions, an additional column, _ncells_, is computed that indicates how many unique cells are present within the bin/region. Do note that if a cell overlaps multiple bins/regions, it will be counted in each bin/region.
#' 
#' Please note that BGI only performs nuclear binning of counts therefore cellular counts obtained will represent nuclear counts only. We recommended that for fair evaluations during benchmarking, alternative binning algorithms that are fair are explored, or analysis be performed on square or hex binned counts.
#' 
#' @return a SpatialExperiment object containing cell/bin/region-level expression quantification.
#' @examples
#' data(tx_small)
#' head(tx_small)
#' tx2spe(tx_small, "region")
#' 
#' @export 
#' 
tx2spe <- function(x, bin = c('cell', 'hex', 'square', 'region'), nbins = 100) {
  required_cols = c("sample_id", "cell", "gene", "genetype", "x", "y", "counts", "technology")

  # checks
  bin = match.arg(bin)
  # missing cols
  missing_cols = setdiff(required_cols, colnames(x))
  if (length(missing_cols) > 0) {
    stop(paste0("The following columns are missing from the provided transcript table 'x': ", paste(missing_cols, collapse = ", ")))
  }
  # invalid bins
  if (nbins <= 0) stop("Value for 'nbins' should be greater than 0")
  if (bin == "region" & !"region" %in% colnames(x)) stop("Required column 'region' missing from the provided transcript table 'x'")
  
  # check types for required cols
  if (!any(x$genetype == "Gene")) stop("No genes found. Ensure genes are marked by \"Gene\" in the \'genetype\' column.")
  if (!is.numeric(x$x)) stop("\"x\" coordinates must be numeric in the transcript table 'x'.")
  if (!is.numeric(x$y)) stop("\"y\" coordinates must be numeric in the transcript table 'x'.")
  if (!is.numeric(x$counts)) stop("\"counts\" coordinates must be numeric in the transcript table 'x'.")

  if (bin == 'cell') {
    warning('Please note that cell segmentation may not be accurate in this data and it may be better to use other binning strategies. Refer to function documentation for details.')
    x = dplyr::mutate(x, cell = as.character(cell))
    x = dplyr::rename(x, bin_id = cell)
  } else if (bin %in% c('hex', 'square', 'region')) {
    allocateFun = switch(
      bin,
      hex = allocateHex,
      square = allocateSquare,
      region = allocateRegion
    )

    #compute binning and the number of cells in the bin
    x = x |> 
      split(x$sample_id) |>
      lapply(\(df) {
        df |>
          cbind(allocateFun(df$x, df$y, bins = nbins, regions = df$region))
      }) |> 
      do.call(what = 'rbind') |> 
      dplyr::group_by(bin_id, .add = TRUE) |> 
      dplyr::mutate(ncells = length(stats::na.omit(unique(cell)))) |> 
      dplyr::ungroup()
    
    if ('technology' %in% colnames(x) & x$technology[1] %in% 'STOmics') {
      x = x |> 
        dplyr::group_by(sample_id, bin_id) |> 
        dplyr::mutate(nspots = sum(!duplicated(paste(x, y, sep = '_')))) |> 
        dplyr::ungroup()
    }
  }

  # create bin annotation
  # process character annotations
  bin_annot = x |>
    dplyr::filter(!is.na(bin_id)) |>
    dplyr::select(!c(gene, genetype)) |>
    dplyr::select(sample_id, bin_id, dplyr::where(is.character)) |>
    dplyr::group_by(sample_id, bin_id) |>
    dplyr::summarise(dplyr::across(everything(),
      ~ ifelse(all(is.na(.x)), NA_character_, table(na.omit(.x)) |> sort() |> names() |> tail(1))
    )) |> 
    dplyr::ungroup()
  
  #process numeric annotations
  bin_annot = x |> 
    dplyr::filter(!is.na(bin_id)) |> 
    dplyr::select(!c(gene, genetype, counts)) |> 
    dplyr::group_by(sample_id, bin_id) |> 
    dplyr::summarise(dplyr::across(dplyr::where(is.numeric), ~ mean(.x, na.rm = TRUE))) |> 
    dplyr::full_join(bin_annot, by = dplyr::join_by(sample_id, bin_id)) |> 
    dplyr::mutate(rname = paste(sample_id, bin_id, sep = '_')) |> 
    as.data.frame()
  #add rownames
  rownames(bin_annot) = bin_annot$rname
  bin_annot = bin_annot |> dplyr::select(!rname)

  #change bin_id to cell/hex id
  colnames(bin_annot)[which(colnames(bin_annot) %in% 'bin_id')] = ifelse(bin == 'cell', 'cell_id', 'bin_id')
  
  #create gene annotation
  gene_annot = x |> 
    dplyr::filter(!is.na(bin_id)) |> 
    dplyr::select(c(gene, genetype)) |> 
    dplyr::filter(!duplicated(paste(gene)))

  #create counts
  counts = x |> 
    dplyr::filter(!is.na(bin_id)) |> 
    dplyr::mutate(
      rname = as.factor(paste(sample_id, bin_id, sep = '_')),
      gene = as.factor(gene)
    ) |> 
    dplyr::select(c(rname, gene, counts)) |> 
    dplyr::group_by(rname, gene) |> 
    dplyr::summarise(counts = sum(counts)) |> 
    with(Matrix::sparseMatrix(
      i = as.numeric(gene),
      j = as.numeric(rname),
      x = counts,
      dimnames = list(levels(gene), levels(rname))
    ))
  counts = counts[gene_annot$gene, rownames(bin_annot)]
  
  #create SPE
  spe = SpatialExperiment::SpatialExperiment(
    assays = list(counts = counts),
    colData = bin_annot,
    rowData = gene_annot,
    spatialCoordsNames = c('x', 'y')
  )

  return(spe)
}

#' Allocate points to hexbins
#'
#' @param x a numeric, containing x-coordinates
#' @param y a numeric, containing y-coordinates
#' @param bins a numeric, stating the number of bins partitioning the range of x 
#' @param ... additional args if needed
#'
#' @return a numeric, containing the index of bins to which each point was allocated
#'
#' @keywords internal
allocateHex <- function(x, y, bins = 30, ...) {
  stopifnot(length(x) == length(y))
  stopifnot(bins > 0)
  
  # compute hexbins
  hx = hexbin::hexbin(x, y, xbins = bins, IDs = TRUE)
  hix = hx@cID

  # compute bin coords
  hxy = hexbin::hcell2xy(hx)
  names(hxy$x) = names(hxy$y) = as.character(hx@cell)

  # compute bin area
  # robustly compute height of triangle in hexagon
  h = diff(hx@xbnds) / hx@xbins * 0.5
  area_hex = h ^ 2 * 6 / sqrt(3)

  hix = data.frame(
    bin_id = hix,
    bin_x = hix %% hx@dimen[2],
    bin_y = hix %/% hx@dimen[2],
    coord_x = hxy$x[as.character(hix)],
    coord_y = hxy$y[as.character(hix)],
    area = area_hex
  )

  return(hix)
}

#' Allocate points to a regular square grid
#'
#' @param x a numeric, containing x-coordinates
#' @param y a numeric, containing y-coordinates
#' @param bins a numeric, stating the number of bins partitioning the range of x 
#' @param ... additional args if needed
#'
#' @return a numeric, containing the index of bins to which each point was allocated
#'
#' @keywords internal
allocateSquare <- function(x, y, bins = 30, ...) {
  stopifnot(length(x) == length(y))
  stopifnot(bins > 0)
  
  # compute bin widths
  yrng = diff(range(y))
  bw = diff(range(x)) / bins
  x = ceiling((x - min(x)) / bw)
  y = ceiling((y - min(y)) / bw)
  x[x == 0] = 1
  y[y == 0] = 1
  max_x = max(x)
  max_y = max(y)

  # compute area
  lasty_bw = yrng %% bw
  if (lasty_bw == 0) {
    area_rect = bw ^ 2
  } else {
    area_rect = ifelse(y == max_y, bw * lasty_bw, bw^2)
  }

  sqix = data.frame(bin_id = x + (y - 1) * max_x, bin_x = x, bin_y = y, area = area_rect)

  return(sqix)
}

#' Allocate points to annotated regions
#'
#' @param x a numeric, containing x-coordinates
#' @param y a numeric, containing y-coordinates
#' @param regions a character, specifying the regions
#' @param ... additional args if needed
#'
#' @return a numeric, containing the index of bins to which each point was allocated
#'
#' @keywords internal
allocateRegion <- function(x, y, regions, ...) {
  stopifnot(length(x) == length(y))
  stopifnot(length(x) == length(regions))
  regions = data.frame(bin_id = regions)
  
  return(regions)
}

test_that("Transcript aggregation works", {
  library(SpatialExperiment)
  library(dplyr)

  data(tx_small)
  required_cols = c("sample_id", "cell", "gene", "genetype", "x", "y", "counts", "technology")

  # check required columns throw errors
  for (i in required_cols) {
    expect_error(tx2spe(tx_small[, setdiff(colnames(tx_small), i)]), "missing")
  }
  expect_error(tx2spe(tx_small[, setdiff(colnames(tx_small), "region")], "region"), "missing")

  # bins > 0
  expect_error(tx2spe(tx_small, "hex", 0), "greater")
  expect_error(tx2spe(tx_small, "square", 0), "greater")

  # test types
  expect_error(tx2spe(mutate(tx_small, x = as.character(x))), "numeric")
  expect_error(tx2spe(mutate(tx_small, y = as.character(y))), "numeric")
  expect_error(tx2spe(mutate(tx_small, counts = as.character(counts))), "numeric")
})

---
title: "SubcellularSpatialData: Annotated spatial transcriptomics datasets from 10x Xenium, NanoString CosMx and BGI STOmics."
author: "Dharmesh D. Bhuva"
date: "`r BiocStyle::doc_date()`"
output:
  prettydoc::html_pretty:
    theme: cayman
    toc: yes
    toc_depth: 2
    number_sections: yes
    fig_caption: yes
    df_print: paged
abstract: > 
  This package provides access to region annotated high-resolution spatial transcriptomics datasets from the 10x Xenium, NanoString CosMx, and BGI STOmics platforms. Regions were annotated independently of the transcriptomic measurements, and therefore form a valuable resource for benchmarking novel computational methods being developed in the field of spatial bioinformatics.

vignette: >
  %\VignetteIndexEntry{SubcellularSpatialData}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  warning = FALSE,
  message = FALSE,
  comment = "#>"
)
```

# SubcellularSpatialData

The data in this package is published in the publication Bhuva et al., _Genome Biology_, 2024. Annotations for each dataset are obtained independently of the molecular measurements. The lowest level of measurement is annotated for each dataset. For BGI STOmics, this is each DNA nanoball, and for 10x Xenium and NanoString CosMx, these are the individual transcript detections. The package provides functions to convert these unit measurements into higher level summaries such as cells, regions, square bins, or hex bins for analysis purposes. These summaries are stored in SpatialExperiment objects.

The SubcellularSpatialData package can be downloaded as follows:

```{r eval=FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("SubcellularSpatialData")
```

# Download data from the SubcellularSpatialData R package

To download the data, we first need to get a list of the data available in the `SubcellularSpatialData` package and determine the unique identifiers for each data. The `query()` function assists in getting this list.

```{r load-packages, message=FALSE}
library(SubcellularSpatialData)
library(ExperimentHub)
```

```{r get-SubcellularSpatialData}
eh = ExperimentHub()
query(eh, "SubcellularSpatialData")
```

Data can then be downloaded using the unique identifier.
```{r download-SubcellularSpatialData, eval=FALSE}
eh[["EH8230"]]
```

As the datasets are large in size, the code above is not executed. Instead, we will explore the package using a subsampled dataset that is available within the package.

```{r}
# load internal sample data
data(tx_small)
# view data
head(tx_small)
```

The data is in the form of a transcript table where the following columns are present across all datasets:

1. _sample_id_ - Unique identifier for the sample the transcript belongs to.
1. _cell_ - Unique identifier for the cell the transcript belongs to (NA if it is not allocated to any cell).
1. _gene_ - Gene name or identity of the transcript.
1. _genetype_ - Type of target (gene or control probe).
1. _x_ - x-coordinate of the transcript.
1. _y_ - y-coordinate of the transcript.
1. _counts_ - Number of transcripts detected at this location (always 1 for NanoString CosMx and 10x Xenium as each row is an individual detection).
1. _region_ - Annotated histological region for the transcript.
1. _technology_ - Name of the platform the data was sequenced on.

Additional columns may be present for different technologies.

We now visualise the data on a spatial plot

```{r}
library(ggplot2)
tx_small |>
  ggplot(aes(x, y, colour = region)) +
  geom_point(pch = ".") +
  scale_colour_brewer(palette = "Set2", guide = guide_legend(override.aes = list(shape = 15, size = 5))) +
  facet_wrap(~sample_id, ncol = 2, scales = "free") +
  theme_minimal() +
  theme(legend.position = "bottom")
```

# Summarising transcripts into cells, bins, and regions

The transcript table is highly detailed containing a low-level form of measurement. Users may be more interestered in working on binned counts, cellular counts, or region-specific pseudo-bulked samples. These can be obtained using the helper function `tx2spe()`. For cellular counts, the original cell binning provided by the vendor is used. Transcript aggregation is performed separately per sample therefore users do not need to separate data per sample.

> Please note that BGI only performs nuclear binning of counts therefore cellular counts obtained will represent nuclear counts only. We recommended that for fair evaluations during benchmarking, alternative binning algorithms that are fair are explored, or analysis be performed on square or hex binned counts.

```{r}
library(SpatialExperiment)

# summarising counts per cell
tx2spe(tx_small, bin = "cell")

# summarising counts per square bin
tx2spe(tx_small, bin = "square", nbins = 30)

# summarising counts per hex bin
tx2spe(tx_small, bin = "hex", nbins = 30)

# summarising counts per region
tx2spe(tx_small, bin = "region")
```

When transcript counts are aggregated (using any approach), aggregation of numeric columns is performed using the `mean(..., na.rm = TRUE)` function and aggregation of character/factor columns is performed such that the most frequent class becomes the representative class. As such, for a hex bin, the highest frequency region for the transcripts allocated to the bin becomes the bin's region annotation. New coordinates for cells, bins, or regions are computed using the mean function as well, therefore represent the center of mass for the object. For hex and square bins, the average coordinate is computed by default, however, x and y indices for the bin are stored in the colData under the *bin_x* and *bin_y* columns. 

When aggregation is perfomed using bins or regions, an additional column, _ncells_, is computed that indicates how many unique cells are present within the bin/region. Do note that if a cell overlaps multiple bins/regions, it will be counted in each bin/region.

# Session Info

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_spe.R
\name{tx2spe}
\alias{tx2spe}
\title{Compute cell/bin-level summaries and save to a SpatialExperiment object}
\usage{
tx2spe(x, bin = c("cell", "hex", "square", "region"), nbins = 100)
}
\arguments{
\item{x}{a data.frame containing a sub-cellular localised dataset from the SubcellularSpatialData package.}

\item{bin}{a character, stating whether transcripts should be binned into cells or hexbins. The default is 'cell', however, it is advisable to use 'hexbin' when cell identification is not accurate (e.g., when cell boundaries are inferred only from nuclei and not directly measured using cytoplasmic/cell membrane stains).}

\item{nbins}{a numeric, stating the number of bins to create in the x and y axes}
}
\value{
a SpatialExperiment object containing cell/bin/region-level expression quantification.
}
\description{
This function summarises transcript detection (or DNA nanoball spot counts) into cells or hexbins and returns a SpatialExperiment object. Annotations of cells or hexbins are summarised such that the most frequent annotation is used.
}
\details{
\subsection{Data description}{

This function works on all data associated with this package. For new datasets, the transcript table MUST have the following columns:
\itemize{
\item{sample_id} {Unique identifier for the sample the transcript belongs to.}
\item{cell} {Unique identifier for the cell the transcript belongs to (NA if it is not allocated to any cell).}
\item{gene} {Gene name or identity of the transcript.}
\item{genetype} {Type of target (e.g., gene or control probe). True genes should be annotated as "Gene". Other target types can be named as desired.}
\item{x} {x-coordinate of the transcript.}
\item{y} {y-coordinate of the transcript.}
\item{counts} {Number of transcripts detected at this location (always 1 for NanoString CosMx and 10x Xenium as each row is an individual detection).}
\item{technology} {Name of the platform the data was sequenced on. "STOmics" is treated differently as the number of spots as well as the number of nuclei/cells are counted. No specific format required for other technologies.}
}

The "region" column is optional and only required if binning by regions. If present, it must be a character or factor. For datasets within this package, this column stored the independently annotated histological region.
}

\subsection{Summarisation}{

When transcript counts are aggregated (using any approach), aggregation of numeric columns is performed using the \code{mean(..., na.rm = TRUE)} function and aggregation of character/factor columns is performed such that the most frequent class becomes the representative class. As such, for a hex bin, the highest frequency region for the transcripts allocated to the bin becomes the bin's region annotation. New coordinates for cells, bins, or regions are computed using the mean function as well, therefore represent the center of mass for the object. For hex and square bins, the average coordinate is computed by default, however, x and y indices for the bin are stored in the colData under the \emph{bin_x} and \emph{bin_y} columns.

When aggregation is perfomed using bins or regions, an additional column, \emph{ncells}, is computed that indicates how many unique cells are present within the bin/region. Do note that if a cell overlaps multiple bins/regions, it will be counted in each bin/region.

Please note that BGI only performs nuclear binning of counts therefore cellular counts obtained will represent nuclear counts only. We recommended that for fair evaluations during benchmarking, alternative binning algorithms that are fair are explored, or analysis be performed on square or hex binned counts.
}
}
\examples{
data(tx_small)
head(tx_small)
tx2spe(tx_small, "region")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_spe.R
\name{allocateSquare}
\alias{allocateSquare}
\title{Allocate points to a regular square grid}
\usage{
allocateSquare(x, y, bins = 30, ...)
}
\arguments{
\item{x}{a numeric, containing x-coordinates}

\item{y}{a numeric, containing y-coordinates}

\item{bins}{a numeric, stating the number of bins partitioning the range of x}

\item{...}{additional args if needed}
}
\value{
a numeric, containing the index of bins to which each point was allocated
}
\description{
Allocate points to a regular square grid
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SubcellularSpatialData.R
\docType{package}
\name{SubcellularSpatialData-package}
\alias{SubcellularSpatialData}
\alias{SubcellularSpatialData-package}
\title{SubcellularSpatialData: Annotated spatial transcriptomics datasets from 10x Xenium, NanoString CosMx and BGI STOmics.}
\description{
This is a data package that hosts annotated sub-cellular localised datasets from the STOmics, Xenium and CosMx platforms. Specifically, it hosts datasets analysed in the publication Bhuva et. al, 2024 titled "Library size confounds biology in spatial transcriptomics data". Raw transcript detections are hosted and functions to convert them to SpatialExperiment objects have been implemented.
}
\details{
The data in this package is published in the publication Bhuva et al., \emph{Genome Biology}, 2024. Annotations for each dataset are obtained independently of the molecular measurements. The lowest level of measurement is annotated for each dataset. For BGI STOmics, this is each DNA nanoball, and for 10x Xenium and NanoString CosMx, these are the individual transcript detections.

The package provides the \code{\link{tx2spe}} function to convert these unit measurements into higher level summaries such as cells, regions, square bins, or hex bins for analysis purposes. These summaries are stored in SpatialExperiment objects.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://davislaboratory.github.io/SubcellularSpatialData}
  \item Report bugs at \url{https://github.com/DavisLaboratory/SubcellularSpatialData/issues}
}

}
\author{
\strong{Maintainer}: Dharmesh D. Bhuva \email{dharmesh.bhuva@adelaide.edu.au} (\href{https://orcid.org/0000-0002-6398-9157}{ORCID})

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SubcellularSpatialData.R
\docType{data}
\name{tx_small}
\alias{tx_small}
\title{Sample annotated sub-cellular localised spatial 'omics dataset}
\format{
A data.frame where each row represents a transcript detection. The full description of these transcript tables is available in the vignettes or in the documentation for the \code{tx2spe()} function.
}
\usage{
tx_small
}
\description{
This object stores a sample transcript table to demonstrate the format of data stored within this package. The sample dataset contains 100,000 transcript detections from 2 breast cancer samples profiled using the 10x Xenium platform.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_spe.R
\name{allocateRegion}
\alias{allocateRegion}
\title{Allocate points to annotated regions}
\usage{
allocateRegion(x, y, regions, ...)
}
\arguments{
\item{x}{a numeric, containing x-coordinates}

\item{y}{a numeric, containing y-coordinates}

\item{regions}{a character, specifying the regions}

\item{...}{additional args if needed}
}
\value{
a numeric, containing the index of bins to which each point was allocated
}
\description{
Allocate points to annotated regions
}
\keyword{internal}
